/*This is a box game made by Tino
www.geocities.com/tinor123*/


#include <stdlib.h>
#include <stdio.h>

#include <math.h>
#include <string.h>
/*These statements get rid of things that are not
need and are in the allegro library*/
#define alleg_gui_unused

#define alleg_vidmem_unused
#define alleg_flic_unused

#include "allegro.h"
/*These statements get rid of things that are not
need and are in the allegro library*/
#ifndef M_PI
   #define M_PI   3.1415926535897932384626433832795
#endif
#define RAD_2_DEG(x) ((x) * 180 / M_PI)
#define DEG_2_RAD(x)    ((x) * M_PI / 180)


#define DRAG 1
#define GROUND_LEVEL SCREEN_H-SCREEN_H/4
#define GRAVITY 32.174

#define BLOB_SIZE 50
#define BLOB_DIA 5
#define BLOB_INC 24
#define BLOB_SPRING ((BLOB_DIA*BLOB_INC)*2)+((BLOB_DIA-1)*(BLOB_INC*2))+BLOB_INC
#define TENSION 5
#define MASS 5
#define DAMP 0
#define MAG(x,y)	(float)sqrt(x*x+y*y) 

BITMAP *buffer;


DATAFILE *datafile;
#include "datafile.h"



int actual_springs=0;





float apply_damping[10]={DAMP,DAMP,DAMP,DAMP,DAMP,DAMP,DAMP,DAMP,DAMP,DAMP,};

float apply_mass[10]={MASS,MASS,MASS,MASS,MASS,MASS,MASS,MASS,MASS,MASS,};
float apply_spring[10]={TENSION,TENSION,TENSION,TENSION,TENSION,TENSION,TENSION,TENSION,TENSION,TENSION,};

float apply_damping_do=2;
float apply_mass_do=MASS;
float apply_mass_spring_do=TENSION;

struct VECTOR
{
	float x;
	float y;
	
};



struct SPRING
{

	struct VECTOR length_rest;
	float mag_rest;

	struct VECTOR length_active;
	float mag_active;
	

	struct VECTOR force;
	float tension;
	float damping;

	int ref1_1;
	int ref1_2;
	int ref2_1;
	int ref2_2;
	int dia;


	
};

struct SKIN
{


	struct VECTOR pos;
	float mass;
	struct VECTOR acc;
	struct VECTOR vel;
	struct VECTOR forces;
};

struct BLOB
{
	float size;
	struct VECTOR pos;
	struct VECTOR vel;
	struct VECTOR force;
	struct VECTOR acc;

	float mass;
	
	
	struct VECTOR center;
	
	struct SKIN skin[BLOB_DIA][BLOB_INC];

	struct SPRING spring[BLOB_SPRING];	

};

struct BLOB blob;
struct BLOB blob_last;

volatile frame_count, framecheck,fps;
volatile timeleftm;
volatile timelefts;
volatile timeleftmm;
volatile time_ms=0;
volatile int speed_counter = 0;

float last_time,dt=0;
    char msg[80];



      /*function to keep game updating user
      inputs at constant speed*/
      void increment_speed_counter()
      {
         speed_counter++;
      }

      END_OF_FUNCTION(increment_speed_counter);


     /*function used to count time
     for when boxes can come out of conveyor*/
  void fps_proc()
{


	  time_ms++;
   fps = frame_count;
   frame_count = 0;

         }

END_OF_FUNCTION(fps_proc);
        /*function for user inputs*/
void input()
{
	int count=0;
	int apply_count[10];
if(key[KEY_LEFT])blob.force.x-=20;
if(key[KEY_RIGHT])blob.force.x+=20;

if(key[KEY_UP])blob.force.y-=70;
if(key[KEY_DOWN])blob.force.y+=70;




if(key[KEY_1])apply_count[0]=TRUE;
else apply_count[0]=FALSE;

if(key[KEY_2])apply_count[1]=TRUE;
else apply_count[1]=FALSE;

if(key[KEY_3])apply_count[2]=TRUE;
else apply_count[2]=FALSE;

if(key[KEY_4])apply_count[3]=TRUE;
else apply_count[3]=FALSE;

if(key[KEY_5])apply_count[4]=TRUE;
else apply_count[4]=FALSE;

if(key[KEY_6])apply_count[5]=TRUE;
else apply_count[5]=FALSE;

if(key[KEY_7])apply_count[6]=TRUE;
else apply_count[6]=FALSE;

if(key[KEY_8])apply_count[7]=TRUE;
else apply_count[7]=FALSE;

if(key[KEY_9])apply_count[8]=TRUE;
else apply_count[8]=FALSE;

if(key[KEY_0])
for(count=0;count<10;count++)
{
apply_damping[count]=apply_damping[0];
apply_mass[count]=apply_mass[0];
apply_spring[count]=apply_spring[0];
}


for(count=0;count<10;count++)
{
if(apply_count[count]==TRUE)
{
if (key[KEY_D]) {
		
		if (key_shifts & KB_SHIFT_FLAG)
		{
		
			
			apply_damping[count]+=0.05;
		}
			else
			{
				if(apply_damping[count]>0)apply_damping[count]-=0.05;
			else apply_damping[count]=0;
			}

	}
if (key[KEY_M]) {
		
		if (key_shifts & KB_SHIFT_FLAG)
		{
		
			
			apply_mass[count]+=0.05;
		}
			else
			{
				if(apply_mass[count]>0)apply_mass[count]-=0.05;
			else apply_mass[count]=0;
			}

	}



if (key[KEY_S]) {
		
		if (key_shifts & KB_SHIFT_FLAG)
		{
		
			
			apply_spring[count]+=0.05;
		}
			else
			{
				if(apply_spring[count]>0)apply_spring[count]-=0.05;
			else apply_spring[count]=0;
			}

	}
}

}

}


update_blob()
{
//int count,count2=0;



	blob.center.x=blob.pos.x;
	blob.center.y=blob.pos.y;

	blob_last.center.x=blob_last.pos.x;
	blob_last.center.y=blob_last.pos.y;
/*
	for(count2=0;count2<BLOB_DIA;count2++)
	for(count=0;count<BLOB_INC;count++)
	{
		blob.skin[count2][count].x=blob.center.x+(blob.size/(BLOB_DIA)*(count2+1))*(sin(DEG_2_RAD(count*(360/BLOB_INC))));
		blob.skin[count2][count].y=blob.center.y+(blob.size/(BLOB_DIA)*(count2+1))*(cos(DEG_2_RAD(count*(360/BLOB_INC))));
	}
*/

}

update_blob_springs()

{
int spring_count,count,count2=0;
float dx_mag,dy_mag,dx,vx,dy,vy=0;

struct VECTOR normal;
float tol=0.001;
float m;
float vel_mag;

spring_count=0;
for(count2=0;count2<BLOB_DIA;count2++)
for(count=0;count<BLOB_INC;count++)
{


if(count2==0)

{

	blob.spring[spring_count].length_active.x=blob.skin[count2][count].pos.x-blob.center.x;
	blob.spring[spring_count].length_active.y=blob.skin[count2][count].pos.y-blob.center.y;
	blob.spring[spring_count].mag_active=MAG(blob.spring[spring_count].length_active.x,blob.spring[spring_count].length_active.y);

	spring_count++;

}



if(count2>0)


{
	
	blob.spring[spring_count].length_active.x=blob.skin[count2][count].pos.x-blob.skin[count2-1][count].pos.x;
	blob.spring[spring_count].length_active.y=blob.skin[count2][count].pos.y-blob.skin[count2-1][count].pos.y;
	blob.spring[spring_count].mag_active=MAG(blob.spring[spring_count].length_active.x,blob.spring[spring_count].length_active.y);

	spring_count++;
}






if(count==BLOB_INC-1) 

{
	blob.spring[spring_count].length_active.x=blob.skin[count2][0].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_active.y=blob.skin[count2][0].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_active=MAG(blob.spring[spring_count].length_active.x,blob.spring[spring_count].length_active.y);

	spring_count++;
	
}	
	else 
		
	{

	blob.spring[spring_count].length_active.x=blob.skin[count2][count+1].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_active.y=blob.skin[count2][count+1].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_active=MAG(blob.spring[spring_count].length_active.x,blob.spring[spring_count].length_active.y);

	spring_count++;

	
	}
	
}

for(count2=0;count2<BLOB_DIA-1;count2++)
for(count=0;count<BLOB_INC;count++)
{

if(count!=BLOB_INC-1)
{
	blob.spring[spring_count].length_active.x=blob.skin[count2+1][count+1].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_active.y=blob.skin[count2+1][count+1].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_active=MAG(blob.spring[spring_count].length_active.x,blob.spring[spring_count].length_active.y);
	spring_count++;
}

else
	{

	blob.spring[spring_count].length_active.x=blob.skin[count2+1][0].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_active.y=blob.skin[count2+1][0].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_active=MAG(blob.spring[spring_count].length_active.x,blob.spring[spring_count].length_active.y);

	spring_count++;

	}
if(count!=0)

{

	blob.spring[spring_count].length_active.x=blob.skin[count2+1][count-1].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_active.y=blob.skin[count2+1][count-1].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_active=MAG(blob.spring[spring_count].length_active.x,blob.spring[spring_count].length_active.y);

	spring_count++;
	
}
else

	{
	
	blob.spring[spring_count].length_active.x=blob.skin[count2+1][BLOB_INC-1].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_active.y=blob.skin[count2+1][BLOB_INC-1].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_active=MAG(blob.spring[spring_count].length_active.x,blob.spring[spring_count].length_active.y);

	spring_count++;

	}


}



count2=BLOB_DIA-1;
for(count=0;count<BLOB_INC;count++)
if(count2==BLOB_DIA-1)


{
	
	blob.spring[spring_count].length_active.x=blob_last.center.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_active.y=blob_last.center.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_active.x,blob.spring[spring_count].length_active.y);




	spring_count++;
}





actual_springs=spring_count;
for(count2=0;count2<BLOB_DIA;count2++)
for(count=0;count<BLOB_INC;count++)
{
blob.skin[count2][count].forces.x=0;
blob.skin[count2][count].forces.y=0;

vel_mag=MAG(blob.skin[count2][count].vel.x,blob.skin[count2][count].vel.y);
normal.x=-blob.skin[count2][count].vel.x;
normal.y=-blob.skin[count2][count].vel.y;
m=MAG(normal.x,normal.y);
if(m<=tol)m=1;

normal.x/=m;
normal.y/=m;

if(fabs(normal.x)<tol)normal.x=0;
if(fabs(normal.y)<tol)normal.y=0;


//blob.skin[count2][count].forces.x+=normal.x*(vel_mag*vel_mag)*DRAG;
//blob.skin[count2][count].forces.y+=normal.y*(vel_mag*vel_mag)*DRAG;

if(count2<10)blob.skin[count2][count].mass=apply_mass[count2];



}

for(count=0;count<spring_count;count++)

{
	




if(blob.spring[count].ref1_1!=-1&&blob.spring[count].ref2_1!=-2)
{
	dx=blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].pos.x-blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].pos.x;
	vx=blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].vel.x-blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].vel.x;
dx_mag=fabs(dx);

	dy=blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].pos.y-blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].pos.y;
	vy=blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].vel.y-blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].vel.y;
dy_mag=fabs(dy);
}
else
{
	if(blob.spring[count].ref1_1==-1)
	{

	dx=blob.center.x-blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].pos.x;
	vx=blob.vel.x-blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].vel.x;
	dx_mag=fabs(dx);
	
	dy=blob.center.y-blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].pos.y;
	vy=blob.vel.y-blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].vel.y;
	dy_mag=fabs(dy);
	}

	if(blob.spring[count].ref2_1==-2)
	{

	dx=blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].pos.x-blob_last.center.x;
	vx=blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].vel.x-blob_last.vel.x;
	dx_mag=fabs(dx);

	dy=blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].pos.y-blob_last.center.y;
	vy=blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].vel.y-blob_last.vel.y;
	dy_mag=fabs(dy);
	
	
	}
	
}




/*

if(blob.spring[count].ref1_1!=-1)
{
	dx=blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].pos.x-blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].pos.x;
	vx=blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].vel.x-blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].vel.x;
dx_mag=fabs(dx);

	dy=blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].pos.y-blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].pos.y;
	vy=blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].vel.y-blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].vel.y;
dy_mag=fabs(dy);
}
else
{
	dx=blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].pos.x-blob.center.x;
	vx=blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].vel.x-blob.vel.x;
dx_mag=fabs(dx);
	dy=blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].pos.y-blob.center.y;
	vy=blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].vel.y-blob.vel.y;
dy_mag=fabs(dy);
}*/
//no damping
//	blob.spring[count].force.x=blob.spring[count].tension*(blob.spring[count].length_active.x-blob.spring[count].length_rest.x);
//	blob.spring[count].force.y=blob.spring[count].tension*(blob.spring[count].length_active.y-blob.spring[count].length_rest.y);
	

		
//*with damping
//	if(dx!=0)
//	blob.spring[count].force.x=-(blob.spring[count].tension*(blob.spring[count].length_active.x)-blob.spring[count].length_rest.x)+
//	blob.spring[count].damping*((vx*blob.spring[count].length_active.x)/dx))*(blob.spring[count].length_active.x/dx);
	

//	else

//		blob.spring[count].force.x=blob.spring[count].tension*(fabs(blob.spring[count].length_active.x)-blob.spring[count].length_rest.x);
//	
//	if(blob.spring[count].length_active.x!=0)
//blob.spring[count].force.x-=blob.spring[count].damping*((vx*dx)/blob.spring[count].length_active.x)*(dx/blob.spring[count].length_active.x);
/*	
if(dy!=0)
	blob.spring[count].force.y=-(blob.spring[count].tension*(fabs(blob.spring[count].length_active.y)-blob.spring[count].length_rest.y)+
	blob.spring[count].damping*((vy*dy)/blob.spring[count].length_active.y))*(dy/blob.spring[count].length_active.y);
	
else
blob.spring[count].force.y=blob.spring[count].tension*(fabs(blob.spring[count].length_active.y)-blob.spring[count].length_rest.y);
	
//	if(blob.spring[count].length_active.y!=0)
//blob.spring[count].force.y-=blob.spring[count].damping*((vy*dy)/blob.spring[count].length_active.y)*(dy/blob.spring[count].length_active.y);
*/
if(blob.spring[count].dia<10)
{

//blob.spring[count].tension=apply_spring[blob.spring[count].dia];
//blob.spring[count].damping=apply_damping[blob.spring[count].dia];

}
/*
if(fabs(dx_mag)>0.0000001)
blob.spring[count].force.x=blob.spring[count].tension*(dx+(blob.spring[count].length_rest.x)-
							 (blob.spring[count].damping)* ( (-vx)/dx_mag ))  
							 ;
else blob.spring[count].force.x=0;

if(fabs(dy_mag)>0.0000001)
blob.spring[count].force.y=blob.spring[count].tension*(dy+(blob.spring[count].length_rest.y)-
							 (blob.spring[count].damping)* ( (-vy)/dy_mag ))  
							 ;
else blob.spring[count].force.y=0;
*/

if(fabs(dx_mag)>0.0000001)
blob.spring[count].force.x=-blob.spring[count].tension*((dx)-(blob.spring[count].length_rest.x));// - blob.spring[count].damping*(-vx);     
else blob.spring[count].force.x=0;
if(fabs(dy_mag)>0.0000001)
blob.spring[count].force.y=-blob.spring[count].tension*(dy-(blob.spring[count].length_rest.y));// - blob.spring[count].damping*(-vy);     
else blob.spring[count].force.y=0;


if(	blob.spring[count].ref1_1!=-1)
{
	blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].forces.x+=blob.spring[count].force.x;
	blob.skin[blob.spring[count].ref1_1][blob.spring[count].ref1_2].forces.y+=blob.spring[count].force.y;
}
else 

{
	

//	blob.force.x+=blob.spring[count].force.x*0.000001;
//	blob.force.y+=blob.spring[count].force.y*0.000001;
}

  if(blob.spring[count].ref2_1!=-2)
  {
	blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].forces.x-=blob.spring[count].force.x;
	blob.skin[blob.spring[count].ref2_1][blob.spring[count].ref2_2].forces.y-=blob.spring[count].force.y;
  }	
	
else
	{
	blob_last.force.x-=blob.spring[count].force.x;
	blob_last.force.y-=blob.spring[count].force.y;
	}
	

	
}



}

void blob_step()

{

int spring_count,count,count2=0;

struct VECTOR normal;
float tol=0.0001;
float m;
float vel_mag;
dt=(time_ms-last_time)*0.005;
last_time=time_ms;

/*
for(count2=0;count2<BLOB_DIA;count2++)
for(count=0;count<BLOB_INC;count++)
{

blob.skin[count2][count].vel.x*=0.8;
blob.skin[count2][count].vel.y*=0.8;
}
*/




for(count2=0;count2<BLOB_DIA;count2++)
for(count=0;count<BLOB_INC;count++)
{
//blob.skin[count2][count].vel.x*=0.9;
//blob.skin[count2][count].vel.y*=0.9;



if(blob.skin[count2][count].pos.y<=GROUND_LEVEL)blob.skin[count2][count].forces.y+=(float)GRAVITY*(blob.skin[count2][count].mass)*0.1;








blob.skin[count2][count].acc.x=blob.skin[count2][count].forces.x/blob.skin[count2][count].mass*1;
blob.skin[count2][count].acc.y=blob.skin[count2][count].forces.y/blob.skin[count2][count].mass*1;

blob.skin[count2][count].vel.x+=blob.skin[count2][count].acc.x*dt;
blob.skin[count2][count].vel.y+=blob.skin[count2][count].acc.y*dt;



blob.skin[count2][count].vel.x*=0.97;
blob.skin[count2][count].vel.y*=0.97;



if(blob.skin[count2][count].vel.x>1500)blob.skin[count2][count].vel.x=1500;
if(blob.skin[count2][count].vel.x<-1500)blob.skin[count2][count].vel.x=-1500;

if(blob.skin[count2][count].vel.y>1500)blob.skin[count2][count].vel.y=1500;
if(blob.skin[count2][count].vel.y<-1500)blob.skin[count2][count].vel.y=-1500;











blob.skin[count2][count].pos.x+=blob.skin[count2][count].vel.x*dt;
blob.skin[count2][count].pos.y+=blob.skin[count2][count].vel.y*dt;


if (blob.skin[count2][count].pos.y>GROUND_LEVEL)blob.skin[count2][count].pos.y=GROUND_LEVEL-1;




}


blob_last.force.x*=0.45;
blob_last.force.y*=0.45;


//if(key[KEY_LEFT])blob_last.force.x-=20000;
//if(key[KEY_RIGHT])blob_last.force.x+=20000;




blob_last.acc.x=blob_last.force.x/blob_last.mass*1;
blob_last.acc.y=blob_last.force.y/blob_last.mass*1;

blob_last.vel.x+=blob_last.acc.x*dt;
blob_last.vel.y+=blob_last.acc.y*dt;







if(blob_last.vel.x>1500)blob_last.vel.x=1500;
if(blob_last.vel.x<-1500)blob_last.vel.x=-1500;

if(blob_last.vel.y>1500)blob_last.vel.y=1500;
if(blob_last.vel.y<-1500)blob_last.vel.y=-1500;





blob_last.vel.x*=0.97;
blob_last.vel.y*=0.97;





blob_last.pos.x+=blob_last.vel.x*dt;
blob_last.pos.y+=blob_last.vel.y*dt;


if (blob_last.pos.y>GROUND_LEVEL)blob_last.pos.y=GROUND_LEVEL-1;

if(blob_last.pos.y<=GROUND_LEVEL)blob_last.force.y+=(float)GRAVITY*(blob_last.mass);

/*

vel_mag=MAG(blob.vel.x,blob.vel.y);
normal.x=-blob.vel.x;
normal.y=-blob.vel.y;
m=MAG(normal.x,normal.y);
if(m<=tol)m=1;

normal.x/=m;
normal.y/=m;

if(fabs(normal.x)<tol)normal.x=0;
if(fabs(normal.y)<tol)normal.y=0;

*/
//blob.force.x+=normal.x*(fabs(blob.vel.x))*DRAG;
//blob.force.y+=normal.y*(fabs(blob.vel.y))*DRAG;






blob.acc.x=blob.force.x/blob.mass;
blob.acc.y=blob.force.y/blob.mass;

blob.vel.x+=blob.acc.x*dt;
blob.vel.y+=blob.acc.y*dt;

blob.pos.x+=blob.vel.x*dt;
blob.pos.y+=blob.vel.y*dt;


//blob.pos.x=400;
//blob.pos.y=300;

//blob.force.y=0;
//blob.force.x=0;

if (blob.pos.y>GROUND_LEVEL)blob.pos.y=GROUND_LEVEL;

if(blob.pos.y<GROUND_LEVEL)blob.force.y+=(float)GRAVITY*(blob.mass);

blob.vel.x*=0.95;
blob.vel.y*=0.95;

blob.force.x*=0.75;
blob.force.y*=0.75;



}


/*This function is used to show the graphics*/
void display()
{
int count,count2=0;
int spring_count=0;

int poly[8];
int poly1[BLOB_INC*2];
struct VECTOR mid_point;

struct VECTOR eyemove;
float nose_y=0;


drawing_mode(DRAW_MODE_COPY_PATTERN, datafile[1].dat, 0, 0);



rectfill(buffer, 0, 0, SCREEN_W, GROUND_LEVEL, 0);
drawing_mode(DRAW_MODE_COPY_PATTERN, datafile[0].dat,0, 0);

rectfill(buffer, 0, GROUND_LEVEL, SCREEN_W, SCREEN_H, 0);




solid_mode();


/*
for(count2=0;count2<BLOB_DIA-1;count2++)
for(count=0;count<BLOB_INC;count++)
circlefill(buffer, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, 2, makecol(255,0,0));

*/
draw_sprite(buffer,datafile[2].dat,SCREEN_W-400,GROUND_LEVEL-256);

for(count2=0;count2<BLOB_DIA;count2++)
for(count=0;count<BLOB_INC;count++)
{


if(count2==0)

	{

//line(buffer, blob.center.x, blob.center.y, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, makecol(255,255,255));

spring_count++;
	}

if(count2>0)
	{

	

//	line(buffer, blob.skin[count2-1][count].pos.x, blob.skin[count2-1][count].pos.y, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, makecol(255,255,255));






spring_count++;
	}

if(count2==BLOB_DIA-1)
	{

	

//line(buffer, blob_last.center.x, blob_last.center.y, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, makecol(255,255,255));





spring_count++;
	}
//	if(count2==BLOB_DIA-1)
  if(count==BLOB_INC-1) 

	{
//line(buffer, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, blob.skin[count2][0].pos.x, blob.skin[count2][0].pos.y, makecol(54,215,118));

spring_count++;

	}
	else 
		
		
	{
		
//line(buffer, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, blob.skin[count2][count+1].pos.x, blob.skin[count2][count+1].pos.y, makecol(54,215,118));

spring_count++;
	}
	
}


for(count2=0;count2<BLOB_DIA-1;count2++)
for(count=0;count<BLOB_INC;count++)
{

if(count!=BLOB_INC-1)
	{

//line(buffer, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, blob.skin[count2+1][count+1].pos.x, blob.skin[count2+1][count+1].pos.y, makecol(128,128,0));
	spring_count++;
	}
else
	{
//line(buffer, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, blob.skin[count2+1][0].pos.x, blob.skin[count2+1][0].pos.y, makecol(128,128,0));
spring_count++;

	}


if(count!=0)
	{
//line(buffer, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, blob.skin[count2+1][count-1].pos.x, blob.skin[count2+1][count-1].pos.y, makecol(128,128,0));
spring_count++;	

	}
else
	{
//line(buffer, blob.skin[count2][count].pos.x, blob.skin[count2][count].pos.y, blob.skin[count2+1][BLOB_INC-1].pos.x, blob.skin[count2+1][BLOB_INC-1].pos.y, makecol(128,128,0));
	
spring_count++;
	}

	
}

/*

mid_point.x=(blob.skin[BLOB_DIA-1][(int)(BLOB_INC*0.25)].pos.x-blob.skin[BLOB_DIA-1][(int)(BLOB_INC*0.75)].pos.x)/2;
mid_point.x+=blob.skin[BLOB_DIA-1][(int)(BLOB_INC*0.75)].pos.x;

mid_point.y=(blob.skin[BLOB_DIA-1][(int)(BLOB_INC*0)].pos.y-blob.skin[BLOB_DIA-1][(int)(BLOB_INC*0.5)].pos.y)/2;
mid_point.y+=blob.skin[BLOB_DIA-1][(int)(BLOB_INC*0.5)].pos.y;


floodfill(buffer,mid_point.x,mid_point.y,makecol(64,225,128));
*/

/*polygon for tail*/
count2=BLOB_DIA;
for(count=0;count<BLOB_INC;count++)
{


	poly[2]=blob_last.pos.x;
	poly[3]=blob_last.pos.y;
	
	poly[4]=blob_last.pos.x;
	poly[5]=blob_last.pos.y;


	poly[0]=blob.skin[count2-1][count].pos.x;
	poly[1]=blob.skin[count2-1][count].pos.y;

	if(count==BLOB_INC-1)
	{
	poly[6]=blob.skin[count2-1][0].pos.x;
	poly[7]=blob.skin[count2-1][0].pos.y;
	}
	
	else
	{
	poly[6]=blob.skin[count2-1][count+1].pos.x;
	poly[7]=blob.skin[count2-1][count+1].pos.y;
	}



/*
if(count>BLOB_INC/2-1)polygon(buffer,4, &poly, makecol(64-count2*4+count,205-count2*16+count,128-count2*4+count));
else*/
polygon(buffer,4, &poly, makecol(64-count2*4+(0),205-count2*16+(0),128-count2*4+(0)));
}
/*polygon's between diameters*/
for(count2=BLOB_DIA-1;count2>0;count2--)
for(count=0;count<BLOB_INC;count++)
{

	if(count2==0)
{
poly[0]=blob.pos.x;
poly[1]=blob.pos.y;
}
	else
	{
poly[0]=blob.skin[count2-1][count].pos.x;
poly[1]=blob.skin[count2-1][count].pos.y;
	}

poly[2]=blob.skin[count2][count].pos.x;
poly[3]=blob.skin[count2][count].pos.y;
	

if(count!=BLOB_INC-1)
{
poly[4]=blob.skin[count2][count+1].pos.x;
poly[5]=blob.skin[count2][count+1].pos.y;

if(count2==0)
{
poly[6]=blob.pos.x;
poly[7]=blob.pos.y;
}
else
{
poly[6]=blob.skin[count2-1][count+1].pos.x;
poly[7]=blob.skin[count2-1][count+1].pos.y;
}


}
		else
		{
		poly[4]=blob.skin[count2][0].pos.x;
		poly[5]=blob.skin[count2][0].pos.y;
		if(count2==0)
		{
		poly[6]=blob.pos.x;
		poly[7]=blob.pos.y;
		}
		else
			{
		poly[6]=blob.skin[count2-1][0].pos.x;
		poly[7]=blob.skin[count2-1][0].pos.y;
			}
		}


if(count2!=0)
{

if(count>BLOB_INC/2-1)polygon(buffer,4, &poly, makecol(64-count2*4+count,205-count2*16+count,128-count2*4+count));
else
polygon(buffer,4, &poly, makecol(64-count2*4+(BLOB_INC-count),205-count2*16+(BLOB_INC-count),128-count2*4+(BLOB_INC-count)));
}



}
/*eyes*/
eyemove.x=blob.vel.x*0.2;
eyemove.y=blob.vel.y*0.2;

if(eyemove.x>2)eyemove.x=2;
if(eyemove.y>2)eyemove.y=2;

if(eyemove.x<-2)eyemove.x=-2;
if(eyemove.y<-2)eyemove.y=-2;

circlefill(buffer, blob.skin[1][(int)(4)].pos.x, blob.skin[1][(int)(4)].pos.y, 10, makecol(255,255,192));
circlefill(buffer, blob.skin[1][(int)(4)].pos.x+eyemove.x*0.75, blob.skin[1][(int)(4)].pos.y+eyemove.y*0.75, 1, makecol(10,30,10));

circlefill(buffer, blob.skin[1][(int)(BLOB_INC-4)].pos.x, blob.skin[1][(int)(BLOB_INC-4)].pos.y, 10, makecol(255,155,155));
circlefill(buffer, blob.skin[1][(int)(BLOB_INC-4)].pos.x+eyemove.x, blob.skin[1][(int)(BLOB_INC-4)].pos.y+eyemove.y, 5, makecol(10,30,10));
/*nose*/
nose_y=blob.skin[0][(int)(0)].pos.y+2;//+(blob.skin[1][(int)(1)].pos.y-blob.skin[0][(int)(0)].pos.y);
circlefill(buffer, blob.skin[0][(int)(0)].pos.x, nose_y, 5, makecol(0,0,0));
circlefill(buffer, blob.skin[0][(int)(0)].pos.x+3, nose_y-3, 2, makecol(96,64,25));
circlefill(buffer, blob.skin[0][(int)(0)].pos.x-3, nose_y-3, 2, makecol(96,64,25));






/*polygon for mouth*/
for(count=0;count<BLOB_INC;count++)
{

poly1[count*2]=blob.skin[0][count].pos.x;
poly1[count*2+1]=blob.skin[0][count].pos.y;

}
/*
polygon(buffer,BLOB_INC, &poly1, makecol(-8+64+count,-16+205+count,-8+128+count));
*/
polygon(buffer,BLOB_INC, &poly1, makecol(148,32,32));





line(buffer, 0, SCREEN_H-SCREEN_H/4, SCREEN_W, SCREEN_H-SCREEN_H/4, makecol(255,255,255));

circlefill(buffer, blob.pos.x, blob.pos.y, 5, makecol(255,255,255));


sprintf(msg, "spring_count=%d,array=%d",actual_springs,BLOB_SPRING);
textout(buffer, font, msg, 0, 420, makecol(200,80,50));
for(count=0;count<10;count++)
{
sprintf(msg, "%d)apply_damping=%f,apply_tension=%f,apply_mass=%f",count,apply_damping[count],apply_spring[count],apply_mass[count]);
textout(buffer, font, msg, 0, 440+count*10, makecol(200,80,50));
}
/*
for(count=0;count<spring_count;count++)

{
sprintf(msg, "%d)rest.x=%.2f,rest.y=%.2f,rest_mag=%.2f",count,blob.spring[count].length_rest.x,blob.spring[count].length_rest.y,blob.spring[count].mag_rest);
textout(buffer, font, msg, 0, count*20, makecol(200,80,50));

sprintf(msg, "%d)active.x=%.2f,active.y=%.2f,active_mag=%.2f",count,blob.spring[count].length_active.x,blob.spring[count].length_active.y,blob.spring[count].mag_active);
textout(buffer, font, msg, 0, count*20+10, makecol(228,200,0));
}
*/
sprintf(msg, "forcex%.2f,forcey%.2f",blob.force.x,blob.force.y);
textout(buffer, font, msg, 0, count*20+10, makecol(228,200,0));

}
RGB_MAP rgb_table;

/* lighting color mapping table */
COLOR_MAP light_table;


void print_progress(int pos)
{
   /*prints the stars that show the progress of creating the color maps*/
   if ((pos & 3) == 3) {
      printf("*");
      fflush(stdout);
   }
}

int main(int argc, char *argv[])
{
 
 PALLETE pal;
 char buf[256];
float set_dia=0;
 int count,count2,spring_count=0;
 int c;
 
     /*This section installs allegro*/
     allegro_init();
     install_keyboard();
     install_mouse();
     install_timer();

     srand(time(NULL));    /*a timer used to create random boxes*/

    /* I took this section of code from the 3d bouncing cubes example
    that comes with allegro*/
    /* color 0 = black */
   pal[0].r = pal[0].g = pal[0].b = 0;

   /* copy the desktop pallete */
   for (c=1; c<64; c++)
      pal[c] = desktop_pallete[c];

   /* make a red gradient */
   for (c=64; c<96; c++) {
      pal[c].r = (c-64)*2;
      pal[c].g = pal[c].b = 0;
   }

   /* make a green gradient */
   for (c=96; c<128; c++) {
      pal[c].g = (c-96)*2;
      pal[c].r = pal[c].b = 0;
   }

   /* set up a greyscale in the top half of the pallete */
   for (c=128; c<256; c++)
      pal[c].r = pal[c].g = pal[c].b = (c-128)/2;

   /* build rgb_map table */
   printf("Generating rgb_map table:\n");
   printf("<................................................................>\r<");
   create_rgb_table(&rgb_table, pal, print_progress);
   rgb_map = &rgb_table;
   printf("\n\n");

   /* build a lighting table */
   printf("Generating lighting table:\n");
   printf("<................................................................>\r<");
   create_light_table(&light_table, pal, 0, 0, 0, print_progress);
   color_map = &light_table;
   printf("\n");


   /*sets the color depth*/
   set_color_depth(32);
   /*set the resolution*/
   set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800,600, 0, 0);


   /*sets the palette to how it is set by the pointer to pal*/
   set_pallete(pal);
   /*loads the boxes.dat datafile and gives it a name
   called datafile so it can be used in functions*/
     /*sets the color depth*/
   set_color_depth(32);
   /*set the resolution*/
   set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 800,600, 0, 0);

   /*sets the palette to how it is set by the pointer to pal*/
   set_pallete(pal);
   /*loads the boxes.dat datafile and gives it a name
   called datafile so it can be used in functions*/


   /* install a digital sound driver 
   if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
      set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
      allegro_message("Error initialising sound system\n%s\n", allegro_error);
      return 1;
   }
*/

 replace_filename(buf, argv[0], "datafile.dat", sizeof(buf));
   datafile = load_datafile(buf);
   if (!datafile) {
      set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
     allegro_message ("Error loading %s!\n\n", buf);
      return 12;
   }






     /*fps timer this function is called every millisecond*/
    install_int(fps_proc, 1);

    /* sets the game speed to 30 frames per second*/
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(60));
    /*locks timer variables explained in allegro manuals*/
    LOCK_VARIABLE(speed_counter);
    LOCK_FUNCTION(increment_speed_counter);

    LOCK_VARIABLE(frame_count);
    LOCK_VARIABLE(fps);
   LOCK_FUNCTION(fps_proc);
   /*creates a buffer the same size as the screen*/
   buffer = create_bitmap (800,600);

   /*sets the background of the text to transparent*/
   text_mode(-1);
   /*sets the digital and midi volumes for the game*/
   set_volume(255, 255);
   /* start title music
     play_sample(datafile[3].dat, 64, 128, 1000, TRUE);
   /*once the user presses the enter button the game will start
   and the level will be selected by the level_select integer*/





memset(&blob,0,sizeof(struct BLOB));

blob.center.x=blob.pos.x=SCREEN_W/2;
blob.center.y=blob.pos.y=SCREEN_H/2;
blob.size=BLOB_SIZE;
blob.mass=MASS;


for(count=0;count<BLOB_SPRING;count++)
{
//blob.spring[count].tension=TENSION*1;
//blob.spring[count].damping=0;

}


	for(count2=0;count2<BLOB_DIA;count2++)
	for(count=0;count<BLOB_INC;count++)
	{
		float count2f=count2+1;
		set_dia=blob.size*fabs(sin(DEG_2_RAD( count2f/(BLOB_DIA+1)*180)));
		//set_dia+=blob.size/10;

		//set_dia*=count2f/BLOB_DIA;
		blob.skin[count2][count].pos.x=blob.center.x+(set_dia)*(sin(DEG_2_RAD(count*(360/BLOB_INC))));
		blob.skin[count2][count].pos.y=blob.center.y-((count2f)/(BLOB_DIA+1))*20+(set_dia)*(cos(DEG_2_RAD(count*(360/BLOB_INC))));

//		blob.skin[count2][count].pos.x=blob.center.x+(blob.size/(BLOB_DIA)*(count2+1))*(sin(DEG_2_RAD(count*(360/BLOB_INC))));
//		blob.skin[count2][count].pos.y=blob.center.y+(blob.size/(BLOB_DIA)*(count2+1))*(cos(DEG_2_RAD(count*(360/BLOB_INC))));
		blob.skin[count2][count].mass=MASS;
	}
blob_last=blob;
blob.mass/=2;
blob_last.mass=MASS;
blob_last.mass*=BLOB_INC;

for(count2=0;count2<BLOB_DIA;count2++)
for(count=0;count<BLOB_INC;count++)
{


if(count2==0)

{

	blob.spring[spring_count].length_rest.x=blob.skin[count2][count].pos.x-blob.center.x;
	blob.spring[spring_count].length_rest.y=blob.skin[count2][count].pos.y-blob.center.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_rest.x,blob.spring[spring_count].length_rest.y);
	
	blob.spring[spring_count].ref1_1=-1;
	blob.spring[spring_count].ref1_2=-1;
	blob.spring[spring_count].ref2_1=count2;
	blob.spring[spring_count].ref2_2=count;
	blob.spring[spring_count].tension=TENSION*(BLOB_DIA-count2)*0.5;

	spring_count++;

}



if(count2>0)


{
	
	blob.spring[spring_count].length_rest.x=blob.skin[count2][count].pos.x-blob.skin[count2-1][count].pos.x;
	blob.spring[spring_count].length_rest.y=blob.skin[count2][count].pos.y-blob.skin[count2-1][count].pos.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_rest.x,blob.spring[spring_count].length_rest.y);


	blob.spring[spring_count].ref1_1=count2-1;
	blob.spring[spring_count].ref1_2=count;
	blob.spring[spring_count].ref2_1=count2;
	blob.spring[spring_count].ref2_2=count;
	blob.spring[spring_count].tension=TENSION*(BLOB_DIA-count2)*0.5;



	spring_count++;
}






if(count==BLOB_INC-1) 

{
	blob.spring[spring_count].length_rest.x=blob.skin[count2][0].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_rest.y=blob.skin[count2][0].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_rest.x,blob.spring[spring_count].length_rest.y);



	blob.spring[spring_count].ref1_1=count2;
	blob.spring[spring_count].ref1_2=count;
	blob.spring[spring_count].ref2_1=count2;
	blob.spring[spring_count].ref2_2=0;
	blob.spring[spring_count].tension=TENSION*(BLOB_DIA-count2)*0.5;

	spring_count++;
	
}	
	else 
		
	{

	blob.spring[spring_count].length_rest.x=blob.skin[count2][count+1].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_rest.y=blob.skin[count2][count+1].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_rest.x,blob.spring[spring_count].length_rest.y);



	blob.spring[spring_count].ref1_1=count2;
	blob.spring[spring_count].ref1_2=count;
	blob.spring[spring_count].ref2_1=count2;
	blob.spring[spring_count].ref2_2=count+1;
	blob.spring[spring_count].tension=TENSION*(BLOB_DIA-count2)*0.5;

	spring_count++;

	
	}
	
}

for(count2=0;count2<BLOB_DIA-1;count2++)
for(count=0;count<BLOB_INC;count++)
{

if(count!=BLOB_INC-1)
{
	blob.spring[spring_count].length_rest.x=blob.skin[count2+1][count+1].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_rest.y=blob.skin[count2+1][count+1].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_rest.x,blob.spring[spring_count].length_rest.y);
	
	blob.spring[spring_count].ref1_1=count2;
	blob.spring[spring_count].ref1_2=count;
	blob.spring[spring_count].ref2_1=count2+1;
	blob.spring[spring_count].ref2_2=count+1;	
	blob.spring[spring_count].tension=TENSION*(BLOB_DIA-count2)*0.5;

	
	
	
	spring_count++;
}

else
	{

	blob.spring[spring_count].length_rest.x=blob.skin[count2+1][0].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_rest.y=blob.skin[count2+1][0].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_rest.x,blob.spring[spring_count].length_rest.y);

	blob.spring[spring_count].ref1_1=count2;
	blob.spring[spring_count].ref1_2=count;
	blob.spring[spring_count].ref2_1=count2+1;
	blob.spring[spring_count].ref2_2=0;	
	blob.spring[spring_count].tension=TENSION*(BLOB_DIA-count2)*0.5;






	spring_count++;

	}
if(count!=0)

{

	blob.spring[spring_count].length_rest.x=blob.skin[count2+1][count-1].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_rest.y=blob.skin[count2+1][count-1].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_rest.x,blob.spring[spring_count].length_rest.y);

	blob.spring[spring_count].ref1_1=count2;
	blob.spring[spring_count].ref1_2=count;
	blob.spring[spring_count].ref2_1=count2+1;
	blob.spring[spring_count].ref2_2=count-1;	
	blob.spring[spring_count].tension=TENSION*(BLOB_DIA-count2)*0.5;






	spring_count++;
	
}
else

	{
	
	blob.spring[spring_count].length_rest.x=blob.skin[count2+1][BLOB_INC-1].pos.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_rest.y=blob.skin[count2+1][BLOB_INC-1].pos.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_rest.x,blob.spring[spring_count].length_rest.y);


	blob.spring[spring_count].ref1_1=count2;
	blob.spring[spring_count].ref1_2=count;
	blob.spring[spring_count].ref2_1=count2+1;
	blob.spring[spring_count].ref2_2=BLOB_INC-1;
	blob.spring[spring_count].tension=TENSION*(BLOB_DIA-count2)*0.5;







	spring_count++;

	}










blob.spring[spring_count].dia=count2;
}

count2=BLOB_DIA-1;
for(count=0;count<BLOB_INC;count++)
if(count2==BLOB_DIA-1)


{
	
	blob.spring[spring_count].length_rest.x=blob_last.center.x-blob.skin[count2][count].pos.x;
	blob.spring[spring_count].length_rest.y=blob_last.center.y-blob.skin[count2][count].pos.y;
	blob.spring[spring_count].mag_rest=MAG(blob.spring[spring_count].length_rest.x,blob.spring[spring_count].length_rest.y);


	blob.spring[spring_count].ref1_1=count2;
	blob.spring[spring_count].ref1_2=count;
	blob.spring[spring_count].ref2_1=-2;
	blob.spring[spring_count].ref2_2=-2;
	blob.spring[spring_count].tension=TENSION;
	blob.spring[spring_count].tension/=BLOB_INC;
	blob.spring[spring_count].tension=TENSION*2;



	spring_count++;
}





    /*This is the main game loop*/

    while (!key[KEY_ESC])
    {

/*
		update_blob();
				blob_step();
				update_blob_springs();
                /*this while statement keeps the game at a constant speed*/
            while (speed_counter > 0)
            {
                input();   /*this function checks for user input*/
                

				update_blob();
				blob_step();
				update_blob_springs();

				

          speed_counter--; /*The speed counter is subtracted every scan that the
                           speed counter is greater than zero and added by the
                           bps function so that when the speed is subtracted
                           more than the bps function adds the while statement
                           will end and display the graphics*/
          /*this line changes the music frequency as the player gets more points*/
          
            }
             /*This function will draw the background and boxes to a buffer*/
             display();
             show_mouse(buffer);
             /*draws the buffer to the screen*/
             blit(buffer,screen,0,0,0,0,800,600);
             show_mouse(NULL);
             /*clears the buffer to a background color*/
             clear_to_color(buffer,makecol(0,0,0));
             /*if the user gets a point the background will be a different
             color for a few seconds*/
      }

return 0;
}

END_OF_MAIN();